/////////////////////////////////////////////////// -*- mode:c++; -*- ////
//  Copyright (C) 2008 by Jonathan Marten				//
//  jjm@keelhaul.me.uk							//
//									//
//  This program is free software; you can redistribute it and/or	//
//  modify it under the terms of the GNU General Public License as	//
//  published by the Free Software Foundation; either version 2 of	//
//  the License, or (at your option) any later version.			//
//									//
//  This program is distributed in the hope that it will be useful,	//
//  but WITHOUT ANY WARRANTY; without even the implied warranty of	//
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	//
//  GNU General Public License for more details.			//
//									//
//  You should have received a copy of the GNU General Public License	//
//  along with this program; if not, write to the			//
//  Free Software Foundation, Inc.,					//
//  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.		//
//									//
//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
//									//
//  This file is part of Kadoom, a KDE desktop front end to various	//
//  Doom game engines.  See http://www.keelhaul.me.uk/linux/kadoom	//
//  for the latest version and further information.			//
//									//
//									//
//  DemoRequester							//
//  -------------							//
//									//
//  This works like a normal URL requester, but if an URL is dragged	//
//  onto the line edit its existing contents are cleared first.		//
//									//
//////////////////////////////////////////////////////////////////////////

#include <kdebug.h>
#include <klineedit.h>

#include <qdragobject.h>

#include "demorequester.h"
#include "demorequester.moc"

//////////////////////////////////////////////////////////////////////////
//									//
//  Line edit, reimplemented						//
//									//
//////////////////////////////////////////////////////////////////////////

class DemoRequesterLineEdit : public KLineEdit
{
public:
	DemoRequesterLineEdit(QWidget *parent);

protected:
	void dropEvent(QDropEvent *ev);
};


DemoRequesterLineEdit::DemoRequesterLineEdit(QWidget *parent)
	: KLineEdit(parent)
{
}


void DemoRequesterLineEdit::dropEvent(QDropEvent *ev)
{
	kdDebug(0) << k_funcinfo << endl;

	clear();					// clear previous contents first
	KLineEdit::dropEvent(ev);			// accept drop as normal
}

//////////////////////////////////////////////////////////////////////////
//									//
//  Constructor/destructor						//
//									//
//////////////////////////////////////////////////////////////////////////

DemoRequester::DemoRequester(QWidget *parent)
	: KURLRequester(new DemoRequesterLineEdit(parent),parent)
{
}
