/////////////////////////////////////////////////// -*- mode:c++; -*- ////
//  Copyright (C) 2008 by Jonathan Marten				//
//  jjm@keelhaul.me.uk							//
//									//
//  This program is free software; you can redistribute it and/or	//
//  modify it under the terms of the GNU General Public License as	//
//  published by the Free Software Foundation; either version 2 of	//
//  the License, or (at your option) any later version.			//
//									//
//  This program is distributed in the hope that it will be useful,	//
//  but WITHOUT ANY WARRANTY; without even the implied warranty of	//
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	//
//  GNU General Public License for more details.			//
//									//
//  You should have received a copy of the GNU General Public License	//
//  along with this program; if not, write to the			//
//  Free Software Foundation, Inc.,					//
//  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.		//
//									//
//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
//									//
//  This file is part of Kadoom, a KDE desktop front end to various	//
//  Doom game engines.  See http://www.keelhaul.me.uk/linux/kadoom	//
//  for the latest version and further information.			//
//									//
//									//
//  EdgeSoundOptions							//
//  ----------------							//
//									//
//  Specific options in the 'Sound' dialogue for the EDGE engine.	//
//									//
//////////////////////////////////////////////////////////////////////////

#include <kdialog.h>
#include <klocale.h>

#include <qcheckbox.h>
#include <qbuttongroup.h>

#include "edgesoundoptions.h"
#include "edgesoundoptions.moc"

//////////////////////////////////////////////////////////////////////////
//									//
//  Constructor/destructor						//
//									//
//////////////////////////////////////////////////////////////////////////

EdgeSoundOptions::EdgeSoundOptions(QWidget *parent,SoundOptions::Option opt)
	: SoundOptions(parent,opt)
{
	cdmusic = new QCheckBox(i18n("CD music"),buttongroup);
							// "CD Music" option
	cdmusic->setChecked(opt & SoundOptions::CDMusic);

	nosfx->setChecked(true);			// this option not supported
	nosfx->setEnabled(false); 

	buttongroup->adjustSize();			// probably needed again
}

//////////////////////////////////////////////////////////////////////////
//									//
//  Returned results							//
//									//
//////////////////////////////////////////////////////////////////////////

SoundOptions::Option EdgeSoundOptions::options() const
{
	int opt = SoundOptions::options();
	if (cdmusic->isChecked()) opt |= SoundOptions::CDMusic;
	return ((SoundOptions::Option) opt);
}
