/////////////////////////////////////////////////// -*- mode:c++; -*- ////
//  Copyright (C) 2008 by Jonathan Marten				//
//  jjm@keelhaul.me.uk							//
//									//
//  This program is free software; you can redistribute it and/or	//
//  modify it under the terms of the GNU General Public License as	//
//  published by the Free Software Foundation; either version 2 of	//
//  the License, or (at your option) any later version.			//
//									//
//  This program is distributed in the hope that it will be useful,	//
//  but WITHOUT ANY WARRANTY; without even the implied warranty of	//
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	//
//  GNU General Public License for more details.			//
//									//
//  You should have received a copy of the GNU General Public License	//
//  along with this program; if not, write to the			//
//  Free Software Foundation, Inc.,					//
//  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.		//
//									//
//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
//									//
//  This file is part of Kadoom, a KDE desktop front end to various	//
//  Doom game engines.  See http://www.keelhaul.me.uk/linux/kadoom	//
//  for the latest version and further information.			//
//									//
//									//
//  InfoDisplay								//
//  -----------								//
//									//
//  Display an information file associated with a WAD or demo.		//
//									//
//////////////////////////////////////////////////////////////////////////


#ifndef __INFODISPLAY_H
#define __INFODISPLAY_H

#include <kurl.h>
#include <kdialogbase.h>

#include <kparts/part.h>

#include <qstringlist.h>

class KURL;
class QWidget;

class InfoDisplay : public KDialogBase
{
	Q_OBJECT

public:
	InfoDisplay(const KURL &s,QWidget *parent = NULL);
	~InfoDisplay();

	bool showInfo();

protected slots:
	void slotFinished();

	void slotListingEntries(KIO::Job *job,const KIO::UDSEntryList &list);
	void slotListingFinished(KIO::Job *job);

private:
	bool tryExists(const KURL &u);

	KURL src;
	KURL url;

	bool needsListing;
	QStringList listingEntries;

	KParts::ReadOnlyPart *m_part;
	QWidget *m_widget;
};

#endif							// INFODISPLAY_H
