/////////////////////////////////////////////////// -*- mode:c++; -*- ////
//  Copyright (C) 2008 by Jonathan Marten				//
//  jjm@keelhaul.me.uk							//
//									//
//  This program is free software; you can redistribute it and/or	//
//  modify it under the terms of the GNU General Public License as	//
//  published by the Free Software Foundation; either version 2 of	//
//  the License, or (at your option) any later version.			//
//									//
//  This program is distributed in the hope that it will be useful,	//
//  but WITHOUT ANY WARRANTY; without even the implied warranty of	//
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	//
//  GNU General Public License for more details.			//
//									//
//  You should have received a copy of the GNU General Public License	//
//  along with this program; if not, write to the			//
//  Free Software Foundation, Inc.,					//
//  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.		//
//									//
//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
//									//
//  This file is part of Kadoom, a KDE desktop front end to various	//
//  Doom game engines.  See http://www.keelhaul.me.uk/linux/kadoom	//
//  for the latest version and further information.			//
//									//
//									//
//  KadoomMainWindow							//
//  ----------------							//
//									//
//  The application main window, menu bar and buttons.			//
//									//
//////////////////////////////////////////////////////////////////////////

#ifndef __KADOOMMAINWINDOW_H
#define __KADOOMMAINWINDOW_H

#include <kmainwindow.h>

class KProcess;
class KAction;

class QWidget;
class QWidgetStack;
class QPushButton;

class GenericGame;

class KadoomMainWindow : public KMainWindow
{
	Q_OBJECT

public:
	KadoomMainWindow();
	virtual ~KadoomMainWindow();

protected:
	void saveProperties(KConfig *);
	void readProperties(KConfig *);

signals:
	void engineChanged();

protected slots:
	void optionsPreferences();
	void slotStartPlay();
	void slotReadyToPlay(bool ok,bool demo);
	void slotConfigureEngine();
	void slotClearCache();
	void slotFinishedPlay(KProcess *proc);


private:
	void setupActions();
	void createEngine(QWidget *parent);

private:
	QString gametype;
	QString gameexec;
	QString gamedata;

	QWidgetStack *gameframe;
	GenericGame *gamewidget;

	QPushButton *startbutton;
	KAction *playgameaction;
};

#endif							// KADOOMMAINWINDOW_H
