/////////////////////////////////////////////////// -*- mode:c++; -*- ////
//  Copyright (C) 2008 by Jonathan Marten				//
//  jjm@keelhaul.me.uk							//
//									//
//  This program is free software; you can redistribute it and/or	//
//  modify it under the terms of the GNU General Public License as	//
//  published by the Free Software Foundation; either version 2 of	//
//  the License, or (at your option) any later version.			//
//									//
//  This program is distributed in the hope that it will be useful,	//
//  but WITHOUT ANY WARRANTY; without even the implied warranty of	//
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	//
//  GNU General Public License for more details.			//
//									//
//  You should have received a copy of the GNU General Public License	//
//  along with this program; if not, write to the			//
//  Free Software Foundation, Inc.,					//
//  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.		//
//									//
//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
//									//
//  This file is part of Kadoom, a KDE desktop front end to various	//
//  Doom game engines.  See http://www.keelhaul.me.uk/linux/kadoom	//
//  for the latest version and further information.			//
//									//
//									//
//  RemoteFiles								//
//  -----------								//
//									//
//  This is the heart of Kadoom's main user convenience:  downloading,	//
//  caching and extracting of remote and archive files.			//
//									//
//////////////////////////////////////////////////////////////////////////

#ifndef __REMOTEFILES_H
#define __REMOTEFILES_H

#include <qdir.h>

#include <kurl.h>

class RemoteFiles
{
public:
	static RemoteFiles *self();

	const QString get(const KURL &src,const char *ext = NULL);
	const QString getWithoutExtracting(const KURL &src);
	const QString lastError() const { return (lastErr); }
	void clearCache();

	KURL isArchiveFile(const KURL &url);

	void saveMatch(const KURL &src,const QString &ext,const QString &match);
	QString cachedMatch(const KURL &src,const QString &ext);

	static QString isAccessibleFile(const KURL &url);
	static QString nameBase(const QString &path);
	static QString nameExt(const QString &path);

protected:
	RemoteFiles();

private:
	QString cacheFile(const KURL &src,const QString &ext);
	QString downloadIntoCache(const KURL &src,const QString &ext);

private:
	QDir cacheDir;
	QString lastErr;
};

#endif							// REMOTEFILES_H
